###################################################
### chunk number 1: 
###################################################
if (!exists("data.table",.GlobalEnv)) library(data.table)  
# In devel won't call library, but R CMD build/check will.
rm(list=as.character(tables()$NAME))  
# for development when we Sweave this file repeatedly. Otherwise first tables() shows tables from last run


###################################################
### chunk number 2: 
###################################################
df = data.frame(x=c("b","b","b","a","a"),v=rnorm(5))
df


###################################################
### chunk number 3: 
###################################################
dt = data.table(x=c("b","b","b","a","a"),v=rnorm(5))
dt


###################################################
### chunk number 4: 
###################################################
cars = data.table(cars)
head(cars)


###################################################
### chunk number 5: 
###################################################
tables()


###################################################
### chunk number 6: 
###################################################
sapply(dt,class)


###################################################
### chunk number 7: 
###################################################
tables()
dt


###################################################
### chunk number 8: 
###################################################
dt[2,]
dt[ dt$x == "b", ]


###################################################
### chunk number 9: 
###################################################
cat(try(dt["b",],silent=TRUE))


###################################################
### chunk number 10: 
###################################################
setkey(dt,x)   # or key(dt)="x" if you prefer
dt


###################################################
### chunk number 11: 
###################################################
tables()


###################################################
### chunk number 12: 
###################################################
dt["b",]


###################################################
### chunk number 13: 
###################################################
dt["b",mult="first"]
dt["b",mult="last"]
dt["b",mult="all"]


###################################################
### chunk number 14: 
###################################################
grpsize = ceiling(1e7/26^2)   # 10 million rows, 676 groups
tt=system.time( DF <- data.frame(
  x=rep(factor(LETTERS),each=26*grpsize),
  y=rep(factor(letters),each=grpsize),
  v=runif(grpsize*26^2))
)
head(DF,3)
tail(DF,3)
dim(DF)


###################################################
### chunk number 15: 
###################################################
tt=system.time(ans1 <- DF[DF$x=="R" & DF$y=="h",])   # 'vector scan'
head(ans1,3)
dim(ans1)


###################################################
### chunk number 16: 
###################################################
DT = data.table(DF)
setkey(DT,x,y)


###################################################
### chunk number 17: 
###################################################
ss=system.time(ans2 <- DT[J("R","h"),mult="all"])   # 'binary search'
mapply(identical,ans1,ans2)


###################################################
### chunk number 18: 
###################################################
system.time(ans1 <- DF[DF$x=="R" & DF$y=="h",])
system.time(ans2 <- DT[DT$x=="R" & DT$y=="h",])
mapply(identical,ans1,ans2)
system.time(ans3 <- DT[x=="R" & y=="h",])
identical(ans2,ans3)


###################################################
### chunk number 19: 
###################################################
identical( DT[J("R","h"),mult="all"],
           DT[data.table("R","h"),mult="all"] )


###################################################
### chunk number 20: 
###################################################
dt[,sum(v)]


###################################################
### chunk number 21: 
###################################################
dt[,sum(v),by=x]


###################################################
### chunk number 22: 
###################################################
ttt=system.time(tt <- tapply(DT$v,DT$x,sum)); ttt
sss=system.time(ss <- DT[,sum(v),by=x]); sss
head(tt)
head(ss)
identical(as.vector(tt), ss$V1)


###################################################
### chunk number 23: 
###################################################
ttt=system.time(tt <- tapply(DT$v,list(DT$x,DT$y),sum)); ttt
sss=system.time(ss <- DT[,sum(v),by="x,y"]); sss
tt[1:5,1:5]
head(ss)
identical(as.vector(t(tt)), ss$V1)


