###################################################
### chunk number 1: 
###################################################
if (!exists("data.table",.GlobalEnv)) library(data.table)  # see Intro.Rnw for comments on these two lines
rm(list=as.character(tables()$NAME))
options(width=70)  # so lines wrap round


###################################################
### chunk number 2: 
###################################################
n = ceiling(1e7/26^2)   # 10 million rows
DF = data.frame(x=rep(LETTERS,each=26*n),
                y=rep(letters,each=n),
                v=rnorm(n*26^2))
DT = data.table(DF,key="x,y")
tables()

tt=system.time(ans1 <- DF[DF$x=="R" & DF$y=="h",]); tt
ss=system.time(ans2 <- DT[J("R","h"),mult="all"]); ss
mapply(identical,ans1,ans2)


###################################################
### chunk number 3: 
###################################################
if(!all(mapply(identical,ans1,ans2))) stop("Test 1 not identical")


###################################################
### chunk number 4: 
###################################################
ttt=system.time(ans1 <- tapply(DF$v,DF$x,sum)); ttt
sss=system.time(ans2 <- DT[,sum(v),by=x]); sss
identical(as.vector(ans1), ans2$V1)


###################################################
### chunk number 5: 
###################################################
if(!identical(as.vector(ans1), ans2$V1)) stop("Test 2 not identical")


###################################################
### chunk number 6: 
###################################################
ans = matrix(c(tt[3],ss[3],ttt[3],sss[3]),byrow=TRUE,ncol=2)
rownames(ans)=c("==","tapply")
colnames(ans)=c("base","data.table")
ans = cbind(ans,"times faster"=as.integer(ans[,1]/ans[,2]))



###################################################
### chunk number 7: 
###################################################
ans


###################################################
### chunk number 8: 
###################################################
toLatex(sessionInfo())


